Patchwork [1/1] initscripts: overwrite default hostname.sh

login
register
mail settings
Submitter jackie huang
Date July 4, 2013, 9:23 a.m.
Message ID <682bcd0939697c34ce9bc7b2fe8f7d734f280490.1372929722.git.jackie.huang@windriver.com>
Download mbox | patch
Permalink /patch/52953/
State Accepted
Commit 5b4494950d125a24927382a4a20af1b9403f1eb6
Headers show

Comments

jackie huang - July 4, 2013, 9:23 a.m.
From: Jackie Huang <jackie.huang@windriver.com>

/etc/init.d/hostname.sh does not have a graceful fallback if the
/etc/hostname file doesn't exist. Other systems such as Ubuntu and RH
will either leave the hostname in place, if a proper hostname is
already set, otherwise it will set the hostname to 'localhost' when
the /etc/hostname files doesn't exist.

As you can see we have to add some additional handling to provide this
behavior when the system's hostname command doesn't take the '-b'
option.

Signed-off-by: Mark Asselstine <mark.asselstine@windriver.com>
Signed-off-by: Jackie Huang <jackie.huang@windriver.com>
---
 .../initscripts/initscripts-1.0/hostname.sh        |   12 ++++++++++--
 1 files changed, 10 insertions(+), 2 deletions(-)

Patch

diff --git a/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh b/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh
index fb58c9c..78fb91c 100755
--- a/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh
+++ b/meta/recipes-core/initscripts/initscripts-1.0/hostname.sh
@@ -7,8 +7,16 @@ 
 # Default-Stop:
 # Short-Description: Set hostname based on /etc/hostname
 ### END INIT INFO
+HOSTNAME=$(/bin/hostname)
 
-if test -f /etc/hostname
-then
+hostname -b -F /etc/hostname 2> /dev/null
+if [ $? -eq 0 ]; then
+	exit
+fi
+
+# Busybox hostname doesn't support -b so we need implement it on our own
+if [ -f /etc/hostname ];then
 	hostname -F /etc/hostname
+elif [ -z "$HOSTNAME" -o "$HOSTNAME" = "(none)" -o ! -z "`echo $HOSTNAME | sed -n '/^[0-9]*\.[0-9].*/p'`" ] ; then
+	hostname localhost
 fi